## Environment

```
#Install gulp
npm install --global gulp
#Install SASS 
gem install sass
#Install Compass
gem update --system
gem install compass
```

## Quick Start 
Recommended to use [Yeoman] (http://yeoman.io/) template [generator-qmui] (https://github.com/QMUI/generator-qmui) to install and configure QMUI Web. The tool can help you complete all the installation and configuration.

```
#Install Yeoman. If you have already installed, please ignore this step.
npm install -g yo
#Install QMUI Template 
npm install -g generator-qmui
#Execute the following command in the root directory of the project
yo qmui
```
<img src="https://raw.githubusercontent.com/QMUI/qmuidemo_web/master/public/style/images/independent/Generator.gif" width="628" alt="效果预览" />

### Project directory structure
```
Root Directory
├─public          // Static resource directory, generated by Compass and gulp
│  ├─js           // Javascript 
│  └─style        // All UI files generate here
│     ├─css       // All styles files generate here
│     └─images    // Images generate here
├─UI_dev          // Development directory 
│  ├─project      // SASS and images files
│  │  ├─images    // Image source directory 
│  │  ├─logic     // SASS file of each module 
│  │  └─widget    // SASS file of components 
│  └─qmui_web     // QMUI Web Source Code 
├─UI_html         // HTML files 
└─UI_html_result  // HTML files compiled by gulp
```
